java.beans

## Class PropertyChangeSupport

- java.lang.Object
- - java.beans.PropertyChangeSupport

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  SwingPropertyChangeSupport

    public class PropertyChangeSupport
    extends Object
    implements Serializable

This is a utility class that can be used by beans that support bound properties. You can use an instance of this class as a member field of your bean and delegate various work to it. This class is serializable. When it is serialized it will save (and restore) any listeners that are themselves serializable. Any non-serializable listeners will be skipped during serialization.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`PropertyChangeSupport(Object sourceBean)` Constructs a `PropertyChangeSupport` object.

### Method Summary

Methods
`void` `addPropertyChangeListener(PropertyChangeListener listener)` Add a PropertyChangeListener to the listener list.
`void` `addPropertyChangeListener(String propertyName, PropertyChangeListener listener)` Add a PropertyChangeListener for a specific property.
`void` `fireIndexedPropertyChange(String propertyName, int index, boolean oldValue, boolean newValue)` Report a `boolean` bound indexed property update to any registered listeners.
`void` `fireIndexedPropertyChange(String propertyName, int index, int oldValue, int newValue)` Report an `int` bound indexed property update to any registered listeners.
`void` `fireIndexedPropertyChange(String propertyName, int index, Object oldValue, Object newValue)` Report a bound indexed property update to any registered listeners.
`void` `firePropertyChange(PropertyChangeEvent evt)` Fire an existing PropertyChangeEvent to any registered listeners.
`void` `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)` Report a boolean bound property update to any registered listeners.
`void` `firePropertyChange(String propertyName, int oldValue, int newValue)` Report an int bound property update to any registered listeners.
`void` `firePropertyChange(String propertyName, Object oldValue, Object newValue)` Report a bound property update to any registered listeners.
`PropertyChangeListener[]` `getPropertyChangeListeners()` Returns an array of all the listeners that were added to the PropertyChangeSupport object with addPropertyChangeListener().
`PropertyChangeListener[]` `getPropertyChangeListeners(String propertyName)` Returns an array of all the listeners which have been associated with the named property.
`boolean` `hasListeners(String propertyName)` Check if there are any listeners for a specific property, including those registered on all properties.
`void` `removePropertyChangeListener(PropertyChangeListener listener)` Remove a PropertyChangeListener from the listener list.
`void` `removePropertyChangeListener(String propertyName, PropertyChangeListener listener)` Remove a PropertyChangeListener for a specific property.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### PropertyChangeSupport

    public PropertyChangeSupport(Object sourceBean)

Constructs a `PropertyChangeSupport` object.

Parameters:
  `sourceBean` - The bean to be given as the source for any events.

### Method Detail

#### addPropertyChangeListener

    public void addPropertyChangeListener(PropertyChangeListener listener)

Add a PropertyChangeListener to the listener list. The listener is registered for all properties. The same listener object may be added more than once, and will be called as many times as it is added. If `listener` is null, no exception is thrown and no action is taken.

Parameters:
  `listener` - The PropertyChangeListener to be added

#### removePropertyChangeListener

    public void removePropertyChangeListener(PropertyChangeListener listener)

Remove a PropertyChangeListener from the listener list. This removes a PropertyChangeListener that was registered for all properties. If `listener` was added more than once to the same event source, it will be notified one less time after being removed. If `listener` is null, or was never added, no exception is thrown and no action is taken.

Parameters:
  `listener` - The PropertyChangeListener to be removed

#### getPropertyChangeListeners

    public PropertyChangeListener[] getPropertyChangeListeners()

Returns an array of all the listeners that were added to the PropertyChangeSupport object with addPropertyChangeListener().

If some listeners have been added with a named property, then the returned array will be a mixture of PropertyChangeListeners and `PropertyChangeListenerProxy`s. If the calling method is interested in distinguishing the listeners then it must test each element to see if it's a `PropertyChangeListenerProxy`, perform the cast, and examine the parameter.

     PropertyChangeListener[] listeners = bean.getPropertyChangeListeners();
     for (int i = 0; i < listeners.length; i++) {
       if (listeners[i] instanceof PropertyChangeListenerProxy) {
         PropertyChangeListenerProxy proxy =
                        (PropertyChangeListenerProxy)listeners[i];
         if (proxy.getPropertyName().equals("foo")) {
           // proxy is a PropertyChangeListener which was associated
           // with the property named "foo"
         }
       }
     }

Returns:
  all of the `PropertyChangeListeners` added or an empty array if no listeners have been added
Since:
  1.4
See Also:
  `PropertyChangeListenerProxy`

#### addPropertyChangeListener

    public void addPropertyChangeListener(String propertyName,
                                 PropertyChangeListener listener)

Add a PropertyChangeListener for a specific property. The listener will be invoked only when a call on firePropertyChange names that specific property. The same listener object may be added more than once. For each property, the listener will be invoked the number of times it was added for that property. If `propertyName` or `listener` is null, no exception is thrown and no action is taken.

Parameters:
  `propertyName` - The name of the property to listen on.
  `listener` - The PropertyChangeListener to be added

#### removePropertyChangeListener

    public void removePropertyChangeListener(String propertyName,
                                    PropertyChangeListener listener)

Remove a PropertyChangeListener for a specific property. If `listener` was added more than once to the same event source for the specified property, it will be notified one less time after being removed. If `propertyName` is null, no exception is thrown and no action is taken. If `listener` is null, or was never added for the specified property, no exception is thrown and no action is taken.

Parameters:
  `propertyName` - The name of the property that was listened on.
  `listener` - The PropertyChangeListener to be removed

#### getPropertyChangeListeners

    public PropertyChangeListener[] getPropertyChangeListeners(String propertyName)

Returns an array of all the listeners which have been associated with the named property.

Parameters:
  `propertyName` - The name of the property being listened to
Returns:
  all of the `PropertyChangeListeners` associated with the named property. If no such listeners have been added, or if `propertyName` is null, an empty array is returned.
Since:
  1.4

#### firePropertyChange

    public void firePropertyChange(String propertyName,
                          Object oldValue,
                          Object newValue)

Report a bound property update to any registered listeners. No event is fired if old and new are equal and non-null.

This is merely a convenience wrapper around the more general firePropertyChange method that takes `PropertyChangeEvent` value.

Parameters:
  `propertyName` - The programmatic name of the property that was changed.
  `oldValue` - The old value of the property.
  `newValue` - The new value of the property.

#### firePropertyChange

    public void firePropertyChange(String propertyName,
                          int oldValue,
                          int newValue)

Report an int bound property update to any registered listeners. No event is fired if old and new are equal.

This is merely a convenience wrapper around the more general firePropertyChange method that takes Object values.

Parameters:
  `propertyName` - The programmatic name of the property that was changed.
  `oldValue` - The old value of the property.
  `newValue` - The new value of the property.

#### firePropertyChange

    public void firePropertyChange(String propertyName,
                          boolean oldValue,
                          boolean newValue)

Report a boolean bound property update to any registered listeners. No event is fired if old and new are equal.

This is merely a convenience wrapper around the more general firePropertyChange method that takes Object values.

Parameters:
  `propertyName` - The programmatic name of the property that was changed.
  `oldValue` - The old value of the property.
  `newValue` - The new value of the property.

#### firePropertyChange

    public void firePropertyChange(PropertyChangeEvent evt)

Fire an existing PropertyChangeEvent to any registered listeners. No event is fired if the given event's old and new values are equal and non-null.

Parameters:
  `evt` - The PropertyChangeEvent object.

#### fireIndexedPropertyChange

    public void fireIndexedPropertyChange(String propertyName,
                                 int index,
                                 Object oldValue,
                                 Object newValue)

Report a bound indexed property update to any registered listeners.

No event is fired if old and new values are equal and non-null.

This is merely a convenience wrapper around the more general firePropertyChange method that takes `PropertyChangeEvent` value.

Parameters:
  `propertyName` - The programmatic name of the property that was changed.
  `index` - index of the property element that was changed.
  `oldValue` - The old value of the property.
  `newValue` - The new value of the property.
Since:
  1.5

#### fireIndexedPropertyChange

    public void fireIndexedPropertyChange(String propertyName,
                                 int index,
                                 int oldValue,
                                 int newValue)

Report an `int` bound indexed property update to any registered listeners.

No event is fired if old and new values are equal.

This is merely a convenience wrapper around the more general fireIndexedPropertyChange method which takes Object values.

Parameters:
  `propertyName` - The programmatic name of the property that was changed.
  `index` - index of the property element that was changed.
  `oldValue` - The old value of the property.
  `newValue` - The new value of the property.
Since:
  1.5

#### fireIndexedPropertyChange

    public void fireIndexedPropertyChange(String propertyName,
                                 int index,
                                 boolean oldValue,
                                 boolean newValue)

Report a `boolean` bound indexed property update to any registered listeners.

No event is fired if old and new values are equal.

This is merely a convenience wrapper around the more general fireIndexedPropertyChange method which takes Object values.

Parameters:
  `propertyName` - The programmatic name of the property that was changed.
  `index` - index of the property element that was changed.
  `oldValue` - The old value of the property.
  `newValue` - The new value of the property.
Since:
  1.5

#### hasListeners

    public boolean hasListeners(String propertyName)

Check if there are any listeners for a specific property, including those registered on all properties. If `propertyName` is null, only check for listeners registered on all properties.

Parameters:
  `propertyName` - the property name.
Returns:
  true if there are one or more listeners for the given property

Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.